include /etc/ql.mak

PGOBJ = page.o
VEOBJ = voxed.o
CLOBJ = client.o
VPOBJ = vplay.o tty.o

OBJS = quite.o jcall.o resize.o
SOBJ = sconfig.o
QOBJ = config.o 
LIBS = -lpick -lmin
CFLAGS = -O 

all: quite pager voxed client vplay

quite: $(OBJS) $(QOBJ)
	$(CC) $(CFLAGS) $(OBJS) $(QOBJ) -o quite $(LIBS)

quiteSH: $(OBJS) $(SOBJ)
	$(CC) $(CFLAGS) $(OBJS) $(SOBJ) -o quiteSH $(LIBS)

qldisk:	quite
	ls -l quite
	qltools /dev/fd0H720 -l -W quite

sconfig.o : config.S
	qcc -c -DSH -P -o sconfig.o config.S

pager: $(PGOBJ)
	$(CC) $(CFLAGS) $(PGOBJ) -o pager

voxed: $(VEOBJ)
	$(CC) $(CFLAGS) $(VEOBJ) -o voxed

client: $(CLOBJ)
	$(CC) $(CFLAGS) $(CLOBJ) -o client -lcsm

vplay: $(VPOBJ)
	$(CC) $(CFLAGS) $(VPOBJ) -o vplay
