#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <qdos.h>

#define CMDBUFSIZE  128

char *promptstr[] = {"OK", "CONNECT", "VCON", "NO ", "BUSY", NULL};

static long serchn = 0;

/*
 * This is only needed for pre v4.20 versions of c68
 */

char * stpcpy(char *d, const char *s)
{
    while(*d++ = *s++)
        ; /* NULL LOOP */
    return d-1;
}

static int faxgets (char *s, int n, int t)
{
    int c = 0;
    char *p;
    char termc = '\n';
    short tlm, tc;
    short first = 1;
    int q = 0;
    
    p = s;
    *p = 0;
    tlm = t * 10;
    tc = 0;
    n--;

    while (n >= 0)
    {
	c = io_fbyte (serchn, 5, p);
	if (c < 0)
	{
	    if (tc++ == tlm)
	    {
		q = -1;
		break;
	    }
	}
	else
	{
	    if (first)
	    {
		if (tolower (*p) == 'a')
		{
		    termc = '\r';
		}
		first = 0;
	    }
	    n--;
	    if (*p++ == termc)
	    {
		break;
	    }
	}
    }
    *p = 0;
    return q;
}

char *strtabmatch (char **p, char *s)
{
    while (*p && strncmp (*p, s, strlen (*p)))
	p++;
    return *p;
}

static char RespBuf[CMDBUFSIZE];

int cmd (char *s, int t)
{
    int p;
    char *pr = RespBuf;

    if (s)
    {
	if (strnicmp (s, "AT", 2))
	{
	    pr = stpcpy (RespBuf, "AT");
	}
	pr = stpcpy(pr, s);
	*pr++ = '\r';
	*pr = 0;
	
	if (io_sstrg (serchn, 250, RespBuf, (pr - RespBuf)) == -1)
	{
	    return -1;
	}
    }

    while ((p = faxgets (RespBuf, CMDBUFSIZE, t)) == 0)
    {
	if (strtabmatch (promptstr, RespBuf))
	{
	    break;
	}
    }
    return p == 0 ? *RespBuf : -1;
}

short ReSync (void)
{
    short err = 0;

    if(!err)
        err = cmd ("Z", 5) != 'O';
    if(!err)
        err = cmd("+FCLASS=8", 5) != 'O';
    if(!err)
        err = cmd("+VIP +FLO=2", 5) != 'O'; 
    return err;
}

void HandleArgs(char *sp, char **dial, char **extra, 
	   long *schn, long *echn)
{
    char *pd;
    short nc;
    char *msp;
    
    nc = *((short *) sp)++;	/* channels */    

    if(nc < 2)
    {
	exit (-15);
    }
    
    msp =  sp + (nc << 2);

    *schn = *((long *) sp)++;
    *echn = *((long *) sp)++;

    sp = msp;
    
    nc = *((short *) sp)++;

    if(nc == 0)
    {
	exit (-15);
    }
    
    pd = *dial = malloc(nc + 8);
    
    *pd++ = 'D';

    while(nc && *sp == ' ')
    {
	*sp++;
	nc--;
    }
    
    while(nc && *sp > ' ')
    {
	*pd++ = *sp++;
    }
    *pd++ = 0;
    

    while(nc && *sp == ' ')
    {
	*sp++;
	nc--;
    }

    if(nc)
    {
	*extra = pd;
    }
    
    while(nc && *sp > '!')
    {
	*pd++ = *sp++;
    }
    *pd++ = 0;
}


int main (int ac, char **av)
{
    char *dial = NULL;
    char *extra = NULL;
    char *emsg = NULL;
    long errchn = 0;

    HandleArgs(*(av + 1), &dial, &extra, &serchn, &errchn);
   
    if(dial)
    {
	if (ReSync () == 0)
	{
	    if (cmd ("+VLS=2", 5) == 'V')
	    {
		if(cmd(dial, 45) != 'V')
		{
		    char *p;
		    if((p = strchr(RespBuf, '\r')))
		    {
			*p = 0;
			emsg = malloc(strlen(RespBuf) + 1);
			strcpy(emsg, RespBuf);
		    }
		}
		else if(extra && *extra)
		{
		    char *p, *q, *r;
		    int n;
		    n = strlen(extra)*2 + 32;
		    if((q = malloc(n)))
		    {
#ifndef NOSTAR
			r = stpcpy(q, "+VTS=*,");
#else
			r = stpcpy(q, "+VTS=");
#endif
			for(p = extra; *p; )
			{
			    *r++ = *p++;
			    *r++ = ',';
			}
			*r++ = '#';
			*r = 0;
#ifdef DELAY
			mt_susjb(-1, 50*DELAY, 0);
#endif
			cmd (q, 5);
			free (q);
		    }
		}
		cmd ("+VLS=0", 5);
	    }
	    else
	    {
		emsg = "modem problem";
	    }
	    cmd("H",5);
	}
	else
	{
	    emsg = "modem not available";
	}
    }
    else
    {
	emsg = "No number!";
    }

    if(emsg && errchn)
    {
	io_sstrg(errchn, 25, emsg, strlen(emsg));
	io_sbyte(errchn, 5, '\n');
    }

    return 0;
}

int (*_Cstart) (int, char **) = main;
