#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include <ctype.h>
#include <fcntl.h>

long (*_cmdchannels) (long) = NULL;
long (*_stackchannels) (long) = NULL;
void (*_consetup) (chanid_t, struct WINDOWDEF *) = NULL;
int (*_conread)  (struct UFB *, void *, unsigned int) = NULL;
int (*_conwrite)  (struct UFB *, void *, unsigned int) = NULL;
char _prog_name[] =   "quite";
void (*_SigStart)(void) = NULL;

static long lit_reset (struct WM_wwork *, short); static long lit_event
(struct WM_wwork *, struct WM_litm *);

static long MMOVE (struct WM_wwork *, struct WM_litm *);
static long AHIT (struct WM_wwork *, struct WM_appw *, struct WM_wstat *, short, short, short);
static long AEXIT (struct WM_wwork *, struct WM_litm *);
static long ADRAW (struct WM_wwork *, struct WM_appw *);

static struct WM_action adraw = {JSR, wm_drwaw, ADRAW};
static struct WM_action aexit = {JSR, wm_actli, AEXIT};
static struct WM_action ahit = {JSR, wm_hitaw, AHIT};
static struct WM_action mmove = {JSR, wm_actli, MMOVE};
static struct WM_action msize = {JSR, wm_actli, lit_event};

static struct WM_wstat ws =	/* window status area */
{
    NULL,		/* *wwork               point back to work def */
    NULL,		/* *wdef                this was wdef */
    0,			/* chid                 chan ID enclosing pointer */
    0, 0, 0,		/* swnr, xpos, ypos     sub-window and ptr posn */
    0, 0,		/* kstk, kprs           key stroke and press */
    0,			/* evnt                 event vector */
    0, 0, 0, 0,		/* xsiz, ysiz, xorg, yorg  */
    0, 0,		/* ptpsx, ptpsy         pointer position (abs) */
    FORM_QL4, 0, 0,	/* wmode, 2 spare       window mode and spare */
    NULL,		/* *ciact               current item "action" */
    -1,			/* citem                current item */
    0, 0, 0,		/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,		/* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}	/* litem[40]            loose item status */
};

#define ninfw    5		/* number of information windows */
#define ninfo    1		/* number of information objects */
#define nlitm    3		/* number of loose items */
#define nappl    1		/* number of application sub-windows */

#define winX     168
#define winY     90

#define MAXW     60
#define MAXL     22

enum cchar
{
    NUL, SOH, STX, ETX, EOT, ENQ, ACK, BEL, BS, HT, LF,
    VT, FF, CR, SO, SI, DLE, XON, DC2, XOFF, DC4, NAK,
    SYN, ETB, CAN, EM, SUB, ESC, FS, GS, RS, US
};

static QD_TEXTI (END, "ESC");
static QD_TEXTI (TITLE, " quite ");

static int pid = 0;
static int kill = 0;

extern char sernam[];
extern char extra[];
extern unsigned short sbaud;
extern unsigned short loop;
extern unsigned short nwait;
extern char mono;
                        
static struct WM_info info[ninfo + 1] =
{
    {42, 10, 6, 0, 0, 0, 2, 0, 0, &TITLE},
    {-1}
};

static struct WM_infw infw[ninfw + 1] =		/* information window */
{
    {winX, 14, 0, 0, 0, 0, 7, 84, NULL},
    {48, 10, (winX-48)/2+4, 2, 0, 0, 0, 7, info},
    {20,10,2,2,0,0,0,7,NULL},
    {20,10,28,2,0,0,0,7,NULL},
    {22,10, winX-24,2, 0, 0, 0, 7, NULL},
    {-1}			/* end of array */
};

extern struct WM_sprite wm_sprite_move;

static struct WM_litm litm[nlitm + 1] =		/* loose item */
{
    {18, 10,   2, 2, 0, 0, 2, K_MOVE,   &wm_sprite_move,    0, &mmove},
    {18, 10,  32, 2, 0, 0, 2, K_SIZE,   &wm_sprite_size,    1, &msize},
    {22, 10, winX-24, 2, 0, 0, 0, K_CANCEL, &END,           2, &aexit},
    {-1}
};

static struct WM_appw aw0 =	/* application sub-window */
{
    winX, winY,		        /* xsize, ysize         size */
    0, 14,			/* xorg, yorg           and origin */
    0,				/* flag                 no clear + shadow */
    0, 0, 7,			/* borw, borc, papr border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    &ahit,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL
};


static struct WM_appl appl[nappl + 1] =
{
    &aw0, NULL
};

static WM_WSCALE (ninfw + ninfo + nlitm + nappl) wsc =
{
    168, 64, MAXW*6, MAXL*10+14, 6, 10,
    {
        {8, 0, 0, 0},           /* infw[0], x scale */
	{0, 0, 4, 0},		/* infw[1], centre */
	{0, 0, 0, 0},  	        /* info[0], no scale */
	{0, 0, 0, 0},		/* infw[2], no scale */
	{0, 0, 0, 0},		/* infw[3], no scale */
	{0, 0, 8, 0},		/* infw[4], right jst */
	{0, 0, 0, 0},		/* litm[0], no scale */
	{0, 0, 0, 0},		/* litm[1], no scale */
	{0, 0, 8, 0},		/* litm[2], right jst */
	{8, 8, 0, 0}		/* appl[0], full scale */
    }
};

static struct WM_wwork ww =	/* window working definition */
{
    &ws,		/* *wstat;              pointer to status area */
    (WM_wscale_t *) & wsc, /* *wscale           this was pointer to WDEF */
    0,			/* chid                 channel ID */
    NULL,		/* *pprec               pointer to pointer record */
    0,			/* psave                pointer position saved */
    0, 0, 0, 0,		/* 4 zero */
    appl,		/* *splst               pointer to sprite list */
    winX, winY+14,	/* xsize, ysize         size */
    0, 0,		/* xorg, yorg           and origin */
    2+NO_WCLEAR,	/* flag                 no clear + shadow */
    1, 4, 7,    	/* borw, borc, papr     border width/clr, paper */
    NULL,		/* *sprite              pointer to sprite */
    1, 0,		/* curw, curc           current item width/clr */
    3, 7, NULL, NULL,	/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt  avail */
    7, 0, NULL, NULL,	/* sback, sink, *sblob, *spatt  selected */
    NULL,		/* *help */
    ninfw, ninfo, infw,	/* ninfo, ninob, *pinfo info winds */
    nlitm, litm,	/* nlitm, *plitm        loose items */
    1, appl		/* nappl  *pappl        appl winds */
};


#define CMDBUFSIZE  128

char *promptstr[] = {"OK", "CONNECT", "VCON", "NO ", "BUSY", "ERROR", NULL};

static long serchn = 0;
static chanid_t chid1;
static short nlin = 0, alin = 0;
static short quiet = 1;

char *stored = NULL;

extern jcall (void (*)(), char *, int, int, int,...);
extern long re_size (struct WM_wwork *, short);
static void PutList(void);

static long lit_reset (struct WM_wwork *wwk, short lit)
{
    wwk->wstat->litem[lit] = WSI_MKAV;
    return wm_ldraw (wwk, -1);
}

static long lit_event (struct WM_wwork *wwk, struct WM_litm *li)
{
    return li->skey + 14;
}

static long AEXIT (struct WM_wwork *wwk, struct WM_litm *li)
{
    int nc;

    kill = 1;
    lit_reset (wwk, li->item);

    for(nc = 0; nc < 500; nc++)
    {
	if(kill == 3) break;
	mt_susjb(-1, 1, NULL);
    }
    exit (0);
}

static long AHIT (struct WM_wwork *wwk, struct WM_appw *apw,
		  struct WM_wstat *wst, short x, short y, short evnt)
{
    static short cnt = 0;
    
    if(kill == 3)
    {
	cnt++;
	if(cnt == 10) wst->evnt |= PT_CAN;
    }
    return 50;
}


static long ADRAW (struct WM_wwork *wwk, struct WM_appw *apw)
{
    int chid;

    chid = *((chanid_t *)apw->pstat);
    wm_swdef (wwk, apw, chid);

    sd_setst(chid, -1, 7);
    sd_setin(chid, -1, 0);
    
    if(stored)
	PutList();
    return 0;
}

static long MMOVE (struct WM_wwork *wwk, struct WM_litm *li)
{
    short dx, dy;
    struct QLRECT rct1, rct2;

    if (pid)
    {
        mt_susjb(pid, -1, NULL);
    }
    sd_pxenq (chid1, -1, &rct1);
    wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
    wm_chwin (wwk, &dx, &dy);	/* move window */

    ADRAW(wwk, &aw0);

    sd_pixp (chid1, -1, rct1.q_x, rct1.q_y);

    if(pid)
    {
        mt_reljb(pid);
    }

    return lit_reset (wwk, li->item);
}

void AddList(char *txt)
{
    char *off;
    
    if(stored)
    {
	off = stored + alin * MAXW;
        strcpy(off, txt);
	alin++;
	alin = alin % MAXL;
	if(nlin < MAXL) nlin++;
    }
}
static short ntop = 0;

void Report (char *ctl,...)
{
    va_list va;
    char txt[128];

    va_start (va, ctl);
    vsprintf (txt, ctl, va);
    va_end (va);
    *(txt+59)=0;
    if(ntop)
    {
	io_sbyte (chid1, 0, '\n');
    }            
    io_sstrg(chid1, 0, txt, strlen(txt));
    AddList(txt);
    ntop = 1;
}

void PutList(void)
{
    char *off;
    short i,j,nl;
    
    if(nlin)
    {
	sd_pos(chid1, -1, 0, 0);
	ntop = 0;
	nl = aw0.ysize/10;
	i = (nl > nlin) ? 0 : nlin - nl;
	
	for(; i < nlin; i++)
	{
	    j = (alin + i) % nlin;
	    off =stored+j*MAXW;
	    if(ntop)
	    {
		io_sbyte (chid1, 0, '\n');
	    }            
	    io_sstrg(chid1, 0, off, strlen(off));
	    ntop = 1;
	}
    }
}

void InitWindow()
{
    ww.chid = io_open("con", 0);

    if (wm_findv (ww.chid))
    {
	chid1 = = io_open("scr", 0);
	aw0.pstat = (char *) &chid1;
	ws.wwork = &ww;		/* set cross reference */
	if(mono)
	{
	    info[0].attr.t.ink = 0;
	    infw[0].papr = 255;
	    ww.borc = 255;
	}
	wm_prpos (&ww, -1, -1);
	wm_wdraw (&ww);
    }
}

static int faxgets (char *s, int n, int t)
{
    int c = 0;
    char *p;
    char termc = '\n';
    short tlm, tc;
    short first = 1;
    int q = 0;
    
    p = s;
    *p = 0;
    tlm = t * 10;
    tc = 0;
    n--;

    while (n >= 0)
    {
	if(kill == 1)
	{
	    io_sstrg(serchn, -1, "AT\r", 3);
	    loop = 0;
	}
	
	c = io_fbyte (serchn, 5, p);
	if (c < 0)
	{
	    if (tc++ == tlm)
	    {
		q = -1;
		break;
	    }
	}
	else
	{
	    if (first)
	    {
		if (tolower (*p) == 'a')
		{
		    termc = '\r';
		}
		first = 0;
	    }
	    n--;
	    if (*p++ == termc)
	    {
		break;
	    }
	}
    }
    *p = 0;
    return q;
}

char *strtabmatch (char **p, char *s)
{
    while (*p && strncmp (*p, s, strlen (*p)))
	p++;
    return *p;
}

static char RespBuf[CMDBUFSIZE];

int cmd (char *s, int t)
{
    int p;
    char *pr = RespBuf;

    if (s)
    {
	if (strnicmp (s, "AT", 2))
	{
	    pr = stpcpy (RespBuf, "AT");
	}
	pr = stpcpy(pr, s);
	*pr = 0;
	if(!quiet)
	    Report("Modem: %*s", (pr - RespBuf) - 1,  RespBuf);
	*pr++ = '\r';
	*pr = 0;

	if (io_sstrg (serchn, 250, RespBuf, (pr - RespBuf)) == -1)
	{
	    return -1;
	}
    }

    while ((p = faxgets (RespBuf, CMDBUFSIZE, t)) == 0)
    {
	if(!quiet)
	{
	    if(*RespBuf > 'A') 
	    {
		char *l;
		
		if((l = strchr(RespBuf, '\r')))
		{
		    *l = 0;
		}
		Report(RespBuf);
	    }	
	}
	
	if (strtabmatch (promptstr, RespBuf))
	{
	    break;
	}
    }
    return p == 0 ? *RespBuf : -1;
}

short ReSync (void)
{
    short err = 0;

    err = cmd ("Z", 5) != 'O';
    if(!err)
        err = cmd("+FCLASS=8", 5) != 'O';
    if(!err)
        err = cmd("+VIP +FLO=2", 5) != 'O'; 
    if(!err && *extra)
        err = cmd(extra, 5) != 'O'; 	
    
    return err;
}

#define MAXDIAL 32
void HandleArgs(char *sp, char *dial)
{
    char *pd = dial+MAXDIAL-1;
    short nc;
    char *p = dial;
    char *msp;
    
    nc = *((short *) sp)++;
    sp =  sp + (nc << 2);
    nc = *((short *) sp)++;

    if(nc == 0)
    {
	exit (-15);
    }
    msp = sp + nc;
    
    while(sp < msp)
    {
	if(*sp == '-' && p == dial)
	{
	    sp++;
	    switch(*sp++)
	    {
	      case 'w':
	      case 'W':
		nwait = strtol(sp, &sp, 10);
		break;
	      case 'n':
	      case 'N':
		loop = strtoul(sp, &sp, 10);
		break;
	      case'v':
	      case 'V':
		quiet = 0;
		break;
	      case 'm':
		mono ^= 1;
		break;
	    }
	}
	else if(*sp > ' ' && p < pd)
	{
	    *p++ = *sp++;
	}
	else sp++;
	
    }
    *p = 0;
    if(loop < 1) loop = 1;
    
}

static int ppid;

DialLoop(char *dial)
{
    int mdm;
    char *emsg = NULL;
    extern int pick (int, int, int, int);

    while (loop--)
    {
	mdm = ReSync ();
	if(mdm == 0)
	{
	    if (cmd ("+VLS=2", 5) == 'V')
	    {
		char dcmd[MAXDIAL+2];
		char *pd;

		pd = dcmd;
		*pd++ = 'D';
		pd = stpcpy(pd, dial);
		*pd = 0;
		
		Report ("Dialing %s", dial);
		if(cmd(dcmd, 45) != 'V')
		{
		    char *p;
		    if((p = strchr(RespBuf, '\r')))
		    {
			*p = 0;
			emsg = malloc(strlen(RespBuf) + 1);
			strcpy(emsg, RespBuf);
		    }
		}
		else
		{
		    Report ("Answered %s", dial);
		    while (kill == 0) mt_susjb(-1, 1, NULL);
		    kill = 2; loop = 0;
		}
	    }
	    else
	    {
		emsg = "modem problem";
	    }
	    cmd ("+VLS=0", 5);
	    cmd("H", 5);
	}
	else
	{
	    emsg = "modem not available";
	    loop = 0;
	}
	if(emsg)
	{
	    Report("error: %s", emsg);
	    mt_susjb(-1, 200, NULL);
	}
	if(loop && nwait)
	{
	    short nc = 50*nwait;
	    Report("Waiting to redial");
	    
	    while(nc--)
	    {
		if(kill) break;
		mt_susjb(-1, 1, NULL);
	    }
	    if(kill) break;
	}
    }
    kill = 3;
    pick (chid1, -1, ppid, K_WAKE);
    return 0;
}

int main (int ac, char **av)
{
    char dial[MAXDIAL] = {0};
    extern int getpid(void);
    
    ppid = getpid();
    
    HandleArgs(*(av + 1), dial);
    if(nwait < 5) nwait = 5;
    if(loop < 1) loop = 1;
    serchn = io_open(sernam, 0);
    if(serchn < 0) return(serchn);
    if(sbaud)
    {
	mt_baud(sbaud);
    }
    
    InitWindow();
    stored = calloc(1, MAXL*MAXW );
    
    pid = jcall((void (*)()) DialLoop, "dial-loop", 8, 3000, 1, dial);

    while(1)
    {
	wm_rptr (&ww);
	if (ws.evnt & PT_WSIZE)
	{
	    re_size(&ww, 1);
	}
	
	if (ws.evnt & PT_CAN)
	{
	    break;
	}

    }
}

int (*_Cstart) (int, char **) = main;

