#ifndef _VFILE_H_
#define _VFILE_H_
#include <time.h>

#ifdef QDOS
#define FLEN 40
#define VOXFILE "vox_dat"
#else
#define FLEN 132
#define VOXFILE "vox.dat"
#endif

typedef struct
{
    time_t   stamp;
    short   status;
    short   type;
    short   epoc;
    char    tsi[24];
    char    name[FLEN];
#ifdef PADDING
    short fill;
#endif

} FVOXREC;

#define FVOXRECLEN sizeof(FVOXREC)

#define VOXTEMP "vox.tmp"

#define NOT_USED    0
#define NOT_SEEN    1
#define SEEN        2
#define FFWD        4

#define FAX         1
#define VOX         2
#define BLEEP       4
#define STATUS      8
    
void ReOrgVoxFile(short);
void AddVoxFile (FVOXREC *);
int ReadVoxFile(FILE *, FVOXREC *);
int UpdateVoxFile(FILE *, FVOXREC *);
FILE * ParseVoxFile(short *nvox, short *nnew, short *nfax);
void CloseVox(FILE *);
int RewindVoxFile (FILE *);
#endif









