#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <ctype.h>
#include "vfile.h"

#ifdef TEST
#define RECLEN 74
#else
#define RECLEN sizeof(FVOXREC)
#endif

typedef struct 
{
    short key;
    char *txt;
} KMAP;

static KMAP types[] = 
    {{FAX,"Fax"},{VOX,"Voice"},{BLEEP,"Bleep"},{STATUS,"Status"},{0}};

static KMAP status [] =
{{NOT_USED,"Un-used"}, {NOT_SEEN, "New"}, {SEEN,"Played"}, 
	   {FFWD, "Forward"},{0}}; 

char *kmatch(KMAP *km, short key)
{
    char *p;
    for(p = NULL; km->txt; km++)
    {
        if(key == km->key)
        {
            p = km->txt;
            break;
        }
    }
    return p;
}

int main(int ac, char **av)
{
    int fd;
    char *fnam = VOXFILE;
    FVOXREC vr;
    short edit = 0;

    while(++av,--ac)
    {
        if(**av == '-')
        {
            switch(*++*av)
            {
                case 'e':
                    edit = 1;
                    break;
            }
        }
        else
        {
            fnam = *av;
        }
    }

    if((fd = open (fnam, O_RDWR)) > 0)
    {
        while(read(fd, &vr, RECLEN) > 0)
        {
            if(vr.status && vr.status != 8)
            {
	        printf ("%24.24s %-7.7s %-5.5s %02d:%02d %23s\n%-58.58s", 
	           ctime(&vr.stamp), kmatch(types, vr.type),
		   kmatch(status, vr.status),
	           vr.epoc / 60, vr.epoc % 60, vr.tsi, vr.name);
                if(edit)
                {
                    char ans[8];
                    fputs(" ... Keep Y/N [Y]\b\b", stdout); fflush(stdout);
                    if(fgets(ans, sizeof(ans)-1, stdin))
                    {
	                if(tolower(*ans) == 'n')
	                {
	                    lseek (fd, -RECLEN, SEEK_CUR);
	                    vr.status = 0;
    	                    write(fd, &vr, RECLEN);
	                }
                    }
                }
                else
                    fputc('\n', stdout);
            }
        }
        close(fd);    
    }
    else
    {
        perror(fnam);
    }
    return 0;
}


